Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBC/obcvol.F90	(revision 3211)
@@ -24,4 +24,10 @@
    PUBLIC obc_vol        ! routine called by dynspg_flt
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "sbc_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -108,7 +114,13 @@
       ! ... East open boundary
       IF( lp_obc_east ) THEN                      ! ... Total transport through the East OBC
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_nie0, fs_nie1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_nie0, fs_nie1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   zubtpecor = zubtpecor - ua(ji,jj,jk)*e2u(ji,jj)*fse3u(ji,jj,jk) * &
              &     uemsk(jj,jk)*MAX(obctmsk(ji,jj),obctmsk(ji+1,jj) )
@@ -120,7 +132,13 @@
       ! ... West open boundary
       IF( lp_obc_west ) THEN                      ! ... Total transport through the West OBC
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_niw0, fs_niw1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   zubtpecor = zubtpecor + ua(ji,jj,jk)*e2u(ji,jj)*fse3u(ji,jj,jk) * &
              &    uwmsk(jj,jk) *MAX(obctmsk(ji,jj),obctmsk(ji+1,jj) )
@@ -128,11 +146,17 @@
             END DO
          END DO
-       ENDIF
+      ENDIF
 
       ! ... North open boundary
       IF( lp_obc_north ) THEN                     ! ... Total transport through the North OBC
+#if defined key_z_first
+         DO ji = 1, jpi
+            DO jj = fs_njn0, fs_njn1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO jj = fs_njn0, fs_njn1 ! Vector opt.
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   zubtpecor = zubtpecor - va(ji,jj,jk)*e1v(ji,jj)*fse3v(ji,jj,jk) * &
              &    vnmsk(ji,jk) * MAX(obctmsk(ji,jj),obctmsk(ji,jj+1) )
@@ -140,11 +164,16 @@
             END DO
          END DO
-       ENDIF
+      ENDIF
 
       ! ... South open boundary
       IF( lp_obc_south ) THEN                     ! ... Total transport through the South OBC
          DO jj = fs_njs0, fs_njs1 ! Vector opt.
+#if defined key_z_first
+            DO ji = 1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji = 1, jpi
+#endif
                   zubtpecor = zubtpecor + va(ji,jj,jk)*e1v(ji,jj)*fse3v(ji,jj,jk) * &
              &    vsmsk(ji,jk) * MAX(obctmsk(ji,jj),obctmsk(ji,jj+1) )
@@ -152,5 +181,5 @@
             END DO
          END DO
-       ENDIF
+      ENDIF
 
       IF( lk_mpp )   CALL mpp_sum( zubtpecor )   ! sum over the global domain
@@ -185,7 +214,13 @@
       IF( lp_obc_west ) THEN
          ! ... correction of the west velocity
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_niw0, fs_niw1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_niw0, fs_niw1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) - zubtpecor*uwmsk(jj,jk)
                   ztransw= ztransw + ua(ji,jj,jk)*fse3u(ji,jj,jk)*e2u(ji,jj)*uwmsk(jj,jk) * &
@@ -203,7 +238,13 @@
 
          ! ... correction of the east velocity
+#if defined key_z_first
+         DO jj = 1, jpj
+            DO ji = fs_nie0, fs_nie1 ! Vector opt.
+               DO jk = 1, jpkm1
+#else
          DO ji = fs_nie0, fs_nie1 ! Vector opt.
             DO jk = 1, jpkm1
                DO jj = 1, jpj
+#endif
                   ua(ji,jj,jk) = ua(ji,jj,jk) + zubtpecor*uemsk(jj,jk)
                   ztranse= ztranse + ua(ji,jj,jk)*fse3u(ji,jj,jk)*e2u(ji,jj)*uemsk(jj,jk) * &
@@ -225,6 +266,11 @@
          ! ... correction of the north velocity
          DO jj = fs_njn0, fs_njn1 ! Vector opt.
+#if defined key_z_first
+            DO ji =  1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji =  1, jpi
+#endif
                   va(ji,jj,jk) = va(ji,jj,jk) + zubtpecor*vnmsk(ji,jk)
                   ztransn= ztransn + va(ji,jj,jk)*fse3v(ji,jj,jk)*e1v(ji,jj)*vnmsk(ji,jk) * &
@@ -245,6 +291,11 @@
          ! ... correction of the south velocity
          DO jj = fs_njs0, fs_njs1 ! Vector opt.
+#if defined key_z_first
+            DO ji =  1, jpi
+               DO jk = 1, jpkm1
+#else
             DO jk = 1, jpkm1
                DO ji =  1, jpi
+#endif
                   va(ji,jj,jk) = va(ji,jj,jk) - zubtpecor*vsmsk(ji,jk)
                   ztranss= ztranss + va(ji,jj,jk)*fse3v(ji,jj,jk)*e1v(ji,jj)*vsmsk(ji,jk) * &
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 3211)
@@ -19,5 +19,4 @@
    USE in_out_manager           ! I/O manager
    USE par_oce
-   USE dom_oce                  ! Ocean space and time domain variables
    USE obs_read_prof            ! Reading and allocation of observations (Coriolis)
    USE obs_read_sla             ! Reading and allocation of SLA observations  
@@ -105,4 +104,7 @@
    LOGICAL, DIMENSION(:), ALLOCATABLE :: &
       & ld_velav     !: Velocity data is daily averaged
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -1023,4 +1025,10 @@
       USE wrk_nemo, ONLY: frld => wrk_2d_1
 #endif
+
+   !! * Control permutation of array indices
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+#  include "oce_ftrans.h90"
+
       IMPLICIT NONE
 
@@ -1081,7 +1089,13 @@
       IF ( ln_sla ) THEN
          DO jslaset = 1, nslasets
+#if defined key_z_first
+            CALL obs_sla_opt( sladatqc(jslaset),            &
+               &              kstp, jpi, jpj, nit000, sshn, &
+               &              tmask_1(:,:), n2dint )
+#else
             CALL obs_sla_opt( sladatqc(jslaset),            &
                &              kstp, jpi, jpj, nit000, sshn, &
                &              tmask(:,:,1), n2dint )
+#endif
          END DO         
       ENDIF
@@ -1090,7 +1104,13 @@
       IF ( ln_sst ) THEN
          DO jsstset = 1, nsstsets
+#if defined key_z_first
+            CALL obs_sst_opt( sstdatqc(jsstset),                 &
+               &              kstp, jpi, jpj, nit000, tn(:,:,1), &
+               &              tmask_1(:,:), n2dint )
+#else
             CALL obs_sst_opt( sstdatqc(jsstset),                 &
                &              kstp, jpi, jpj, nit000, tn(:,:,1), &
                &              tmask(:,:,1), n2dint )
+#endif
          END DO
       ENDIF
@@ -1427,4 +1447,7 @@
          & rdt
 
+   !! * Control permutation of array indices
+!FTRANS CLEAR
+
       IMPLICIT NONE
 
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/mpp_map.F90	(revision 3211)
@@ -24,4 +24,7 @@
 
    INTEGER, DIMENSION(:,:), ALLOCATABLE ::   mppmap   ! ???
+
+   !! * Control permutation of array indices
+   !! No array indices to control
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90	(revision 3211)
@@ -85,4 +85,7 @@
       & grid_search_file    ! file name head for grid search lookup 
 
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -128,31 +131,47 @@
          ELSE
             IF ( cdgrid == 'T' ) THEN
-               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             nldi, nlei,nldj,  nlej,   &
-                  &                             nproc, jpnij,             &
-                  &                             glamt, gphit, tmask,      &
-                  &                             kobsin, plam, pphi,       &
-                  &                             kobsi, kobsj, kproc )
+               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,        &
+                  &                     nldi, nlei,nldj,  nlej,          &
+                  &                     nproc, jpnij,                    &
+#if defined key_z_first
+                  &                     glamt, gphit, tmask_1(:,:),      &
+#else
+                  &                     glamt, gphit, tmask(:,:,1),      &
+#endif
+                  &                     kobsin, plam, pphi,              &
+                  &                     kobsi, kobsj, kproc )
             ELSEIF ( cdgrid == 'U' ) THEN
-               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             nldi, nlei,nldj,  nlej,   &
-                  &                             nproc, jpnij,             &
-                  &                             glamu, gphiu, umask,      &
-                  &                             kobsin, plam, pphi,       &
-                  &                             kobsi, kobsj, kproc )
+               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,        &
+                  &                     nldi, nlei,nldj,  nlej,          &
+                  &                     nproc, jpnij,                    &
+#if defined key_z_first
+                  &                     glamu, gphiu, umask_1(:,:),      &
+#else
+                  &                     glamu, gphiu, umask(:,:,1),      &
+#endif
+                  &                     kobsin, plam, pphi,              &
+                  &                     kobsi, kobsj, kproc )
             ELSEIF ( cdgrid == 'V' ) THEN
-               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             nldi, nlei,nldj,  nlej,   &
-                  &                             nproc, jpnij,             &
-                  &                             glamv, gphiv, vmask,      &
-                  &                             kobsin, plam, pphi,       &
-                  &                             kobsi, kobsj, kproc )
+               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,        &
+                  &                     nldi, nlei,nldj,  nlej,          &
+                  &                     nproc, jpnij,                    &
+#if defined key_z_first
+                  &                     glamv, gphiv, vmask_1(:,:),      &
+#else
+                  &                     glamv, gphiv, vmask(:,:,1),      &
+#endif
+                  &                     kobsin, plam, pphi,              &
+                  &                     kobsi, kobsj, kproc )
             ELSEIF ( cdgrid == 'F' ) THEN
-               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo, &
-                  &                             nldi, nlei,nldj,  nlej,   &
-                  &                             nproc, jpnij,             &
-                  &                             glamf, gphif, fmask,      &
-                  &                             kobsin, plam, pphi,       &
-                  &                             kobsi, kobsj, kproc )
+               CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,        &
+                  &                     nldi, nlei,nldj,  nlej,          &
+                  &                     nproc, jpnij,                    &
+#if defined key_z_first
+                  &                     glamf, gphif, fmask_1(:,:),      &
+#else
+                  &                     glamf, gphif, fmask(:,:,1),      &
+#endif
+                  &                     kobsin, plam, pphi,              &
+                  &                     kobsi, kobsj, kproc )
             ELSE
                CALL ctl_stop( 'Grid not supported' )
@@ -283,5 +302,9 @@
                zlamg(mig(ji),mjg(jj)) = glamt(ji,jj)
                zphig(mig(ji),mjg(jj)) = gphit(ji,jj)
+#if defined key_z_first
+               zmskg(mig(ji),mjg(jj)) = tmask_1(ji,jj)
+#else
                zmskg(mig(ji),mjg(jj)) = tmask(ji,jj,1)
+#endif
             END DO
          END DO
@@ -295,5 +318,9 @@
                zlamg(ji,jj) = glamt(ji,jj)
                zphig(ji,jj) = gphit(ji,jj)
+#if defined key_z_first
+               zmskg(ji,jj) = tmask_1(ji,jj)
+#else
                zmskg(ji,jj) = tmask(ji,jj,1)
+#endif
             END DO
          END DO
@@ -813,9 +840,9 @@
             END DO
             
-            CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,  &
-               &                     nldi, nlei,nldj,  nlej,    &
-               &                     nproc, jpnij,              &
-               &                     glamt, gphit, tmask,       &
-               &                     nlons*nlats, lonsi, latsi, &
+            CALL obs_grd_bruteforce( jpi, jpj, jpiglo, jpjglo,   &
+               &                     nldi, nlei,nldj,  nlej,     &
+               &                     nproc, jpnij,               &
+               &                     glamt, gphit, tmask(:,:,1), &
+               &                     nlons*nlats, lonsi, latsi,  &
                &                     ixposi, iyposi, iproci )
             
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_sup.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_sup.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_sup.F90	(revision 3211)
@@ -26,4 +26,7 @@
       &   obs_int_comm_2d    ! Get 2D interpolation stencil
    
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -58,14 +61,26 @@
       INTEGER, INTENT(IN) :: kpk       ! Number of levels
       INTEGER, DIMENSION(kptsi,kptsj,kobs), INTENT(IN) :: &
-         & kgrdi, &         ! i,j indicies for each stencil
+         & kgrdi, &         ! i,j indices for each stencil
          & kgrdj
       INTEGER, OPTIONAL, DIMENSION(kptsi,kptsj,kobs), INTENT(IN) :: &
          & kproc            ! Precomputed processor for each i,j,iobs points
-      REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
-         & pval             ! Local 3D array to extract data from
+
+!! DCSE_NEMO: This style defeats ftrans
+!      REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
+!        & pval             ! Local 3D array to extract data from
+!FTRANS pval :I :I :z
+      REAL(KIND=wp), INTENT(IN) ::&
+         & pval(jpi,jpj,kpk) ! Local 3D array to extract data from
       REAL(KIND=wp), DIMENSION(kptsi,kptsj,kpk,kobs), INTENT(OUT) ::&
          & pgval            ! Stencil at each point
       !! * Local declarations
       
+#if defined key_z_first
+      IF ( kpk /= jpk ) THEN
+         CALL ctl_stop( 'Error in obs_int_comm_3d', &
+            &           'index reordering requires that jpk==kpk' )
+      ENDIF
+#endif
+
       IF (ln_grid_global) THEN
          
@@ -107,4 +122,11 @@
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: wrk_3d_1
+
+   !! * Control permutation of array indices
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+!FTRANS wrk_3d_1 :I :I :z
+!FTRANS zval :I :I :z
+
       !!
       !! * Arguments
@@ -132,5 +154,6 @@
          RETURN
       END IF
-      zval => wrk_3d_1(:,:,1:1)
+
+      zval => wrk_3d_1
 
       ! Set up local "3D" buffer
@@ -139,4 +162,8 @@
 
       ! Call the 3D version
+
+!! DCSE_NEMO: this is not going to work with index re-ordering
+!! Really want obs_int_comm_2d to do its own stuff, instead of calling
+!! obs_int_comm_3d !!
 
       IF (PRESENT(kproc)) THEN
@@ -184,12 +211,27 @@
       INTEGER, INTENT(IN) :: kpk       ! Number of levels
       INTEGER, DIMENSION(kptsi,kptsj,kobs), INTENT(IN) :: &
-         & kgrdi, &         ! i,j indicies for each stencil
+         & kgrdi, &         ! i,j indices for each stencil
          & kgrdj
       INTEGER, OPTIONAL, DIMENSION(kptsi,kptsj,kobs), INTENT(IN) :: &
          & kproc            ! Precomputed processor for each i,j,iobs points
-      REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
-         & pval             ! Local 3D array to extract data from
-      REAL(KIND=wp), DIMENSION(kptsi,kptsj,kpk,kobs), INTENT(OUT) ::&
-         & pgval            ! Stencil at each point
+
+   !! * Control permutation of array indices
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+
+!! DCSE_NEMO: this style defeats ftrans
+!     REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
+!        & pval             ! Local 3D array to extract data from
+!     REAL(KIND=wp), DIMENSION(kptsi,kptsj,kpk,kobs), INTENT(OUT) ::&
+!        & pgval            ! Stencil at each point
+
+!FTRANS pval :I :I :z
+      REAL(KIND=wp), INTENT(IN) ::&
+         & pval(jpi,jpj,kpk)             ! Local 3D array to extract data from
+
+!FTRANS pgval :I :I :z :
+      REAL(KIND=wp), INTENT(OUT) ::&
+         & pgval(kptsi,kptsj,kpk,kobs)   ! Stencil at each point
+
       !! * Local declarations
       REAL(KIND=wp), DIMENSION(:,:), ALLOCATABLE :: &
@@ -281,5 +323,5 @@
       END DO
 
-      ! Send and recieve buffers for list of points
+      ! Send and receive buffers for list of points
 
       CALL mpp_alltoallv_int( igrdij_send, kptsi*kptsj*kobs*2, nplocal(:)*2, &
@@ -320,5 +362,5 @@
       END DO
 
-      ! Deallocate message parsing workspace
+      ! Deallocate message passing workspace
 
       DEALLOCATE( &
@@ -353,10 +395,24 @@
       INTEGER, INTENT(IN) :: kpk          ! Number of levels
       INTEGER, DIMENSION(kptsi,kptsj,kobs), INTENT(IN) :: &
-         & kgrdi, &         ! i,j indicies for each stencil
+         & kgrdi, &         ! i,j indices for each stencil
          & kgrdj
-      REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
-         & pval             ! Local 3D array to extract data from
-      REAL(KIND=wp), DIMENSION(kptsi,kptsj,kpk,kobs), INTENT(OUT) ::&
-         & pgval            ! Stencil at each point
+
+   !! * Control permutation of array indices
+!FTRANS CLEAR
+#  include "dom_oce_ftrans.h90"
+
+!! DCSE_NEMO: this style defeats ftrans
+!     REAL(KIND=wp), DIMENSION(jpi,jpj,kpk), INTENT(IN) ::&
+!        & pval             ! Local 3D array to extract data from
+!     REAL(KIND=wp), DIMENSION(kptsi,kptsj,kpk,kobs), INTENT(OUT) ::&
+!        & pgval            ! Stencil at each point
+
+!FTRANS pval :I :I :z
+      REAL(KIND=wp), INTENT(IN)  ::&
+         & pval(jpi,jpj,kpk)             ! Local 3D array to extract data from
+!FTRANS pgval :I :I :z :
+      REAL(KIND=wp), INTENT(OUT) ::&
+         & pgval(kptsi,kptsj,kpk,kobs)   ! Stencil at each point
+
       !! * Local declarations
       INTEGER ::  ji
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 3211)
@@ -55,4 +55,7 @@
    INTEGER, PARAMETER, PUBLIC :: imaxavtypes = 20 ! Max number of daily avgd obs types
 
+   !! * Control permutation of array indices
+   !! None required from dom_oce_ftrans.h90
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -133,8 +136,15 @@
       INTEGER, INTENT(IN) :: k2dint    ! Horizontal interpolation type (see header)
       INTEGER, INTENT(IN) :: kdaystp   ! Number of time steps per day                    
-      REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj,kpk) :: &
-         & ptn,    &    ! Model temperature field
-         & psn,    &    ! Model salinity field
-         & ptmask       ! Land-sea mask
+!! DCSE_NEMO : this style defeats ftrans
+!     REAL(KIND=wp), INTENT(IN), DIMENSION(kpi,kpj,kpk) :: &
+!        & ptn,    &    ! Model temperature field
+!        & psn,    &    ! Model salinity field
+!        & ptmask       ! Land-sea mask
+
+!FTRANS ptn psn ptmask :I :I :z
+      REAL(KIND=wp), INTENT(IN) :: ptn(kpi,kpj,kpk)    ! Model temperature field
+      REAL(KIND=wp), INTENT(IN) :: psn(kpi,kpj,kpk)    ! Model salinity field
+      REAL(KIND=wp), INTENT(IN) :: ptmask(kpi,kpj,kpk) ! Land-sea mask
+
       REAL(KIND=wp), INTENT(IN), DIMENSION(kpk) :: &
          & pgdept       ! Model array of depth levels
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 3211)
@@ -42,4 +42,7 @@
       & obs_pre_vel, &     ! First level check and screening of velocity profiles
       & calc_month_len     ! Calculate the number of days in the months of a year  
+
+   !! * Control permutation of array indices
+   !! No arrays with indices to permute.
 
    !!----------------------------------------------------------------------
@@ -356,4 +359,12 @@
       USE domstp              ! Domain: set the time-step
       USE par_oce             ! Ocean parameters
+#if defined key_z_first
+      USE dom_oce, ONLY : &   ! Geographical information
+         & glamt,   &
+         & gphit,   &
+         & tmask,   &
+         & tmask_1, &
+         & nproc
+#else
       USE dom_oce, ONLY : &   ! Geographical information
          & glamt,   &
@@ -361,4 +372,9 @@
          & tmask,   &
          & nproc
+#endif
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
       !! * Arguments
       TYPE(obs_surf), INTENT(INOUT) :: sladata    ! Full set of SLA data
@@ -440,5 +456,9 @@
          &                 sladata%rlam, sladata%rphi, &
          &                 glamt,        gphit,        &
+#if defined key_z_first
+         &                 tmask_1(:,:), sladata%nqc,  &
+#else
          &                 tmask(:,:,1), sladata%nqc,  &
+#endif
          &                 iosdsobs,     ilansobs,     &
          &                 inlasobs,     ld_nea        )
@@ -526,4 +546,8 @@
    END SUBROUTINE obs_pre_sla
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+   !! No arrays with indices to permute.
+
    SUBROUTINE obs_pre_sst( sstdata, sstdatqc, ld_sst, ld_nea )
       !!----------------------------------------------------------------------
@@ -544,4 +568,12 @@
       USE domstp              ! Domain: set the time-step
       USE par_oce             ! Ocean parameters
+#if defined key_z_first
+      USE dom_oce, ONLY : &   ! Geographical information
+         & glamt,   &
+         & gphit,   &
+         & tmask,   &
+         & tmask_1, &
+         & nproc
+#else
       USE dom_oce, ONLY : &   ! Geographical information
          & glamt,   &
@@ -549,4 +581,9 @@
          & tmask,   &
          & nproc
+#endif
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
       !! * Arguments
       TYPE(obs_surf), INTENT(INOUT) :: sstdata     ! Full set of SST data
@@ -625,5 +662,9 @@
          &                 sstdata%rlam, sstdata%rphi, &
          &                 glamt,        gphit,        &
+#if defined key_z_first
+         &                 tmask_1(:,:), sstdata%nqc,  &
+#else
          &                 tmask(:,:,1), sstdata%nqc,  &
+#endif
          &                 iosdsobs,     ilansobs,     &
          &                 inlasobs,     ld_nea        )
@@ -711,4 +752,8 @@
    END SUBROUTINE obs_pre_sst
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+   !! No arrays with indices to permute.
+
    SUBROUTINE obs_pre_seaice( seaicedata, seaicedatqc, ld_seaice, ld_nea )
       !!----------------------------------------------------------------------
@@ -733,5 +778,12 @@
          & gphit,   &
          & tmask,   &
+#if defined key_z_first
+         & tmask_1, &
+#endif
          & nproc
+
+      !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
       !! * Arguments
       TYPE(obs_surf), INTENT(INOUT) :: seaicedata     ! Full set of Sea Ice data
@@ -810,5 +862,9 @@
          &                 seaicedata%rlam, seaicedata%rphi, &
          &                 glamt,           gphit,           &
+#if defined key_z_first
+         &                 tmask_1(:,:),    seaicedata%nqc,  &
+#else
          &                 tmask(:,:,1),    seaicedata%nqc,  &
+#endif
          &                 iosdsobs,        ilansobs,        &
          &                 inlasobs,        ld_nea           )
@@ -896,4 +952,8 @@
    END SUBROUTINE obs_pre_seaice
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+   !! No arrays with indices to permute.
+
    SUBROUTINE obs_pre_vel( profdata, prodatqc, ld_vel3d, ld_nea, ld_dailyav )
       !!----------------------------------------------------------------------
@@ -919,4 +979,8 @@
          & tmask, umask, vmask,  &
          & nproc
+
+      !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
       !! * Arguments
       TYPE(obs_prof), INTENT(INOUT) :: profdata   ! Full set of profile data
@@ -1188,4 +1252,8 @@
    END SUBROUTINE obs_pre_vel
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+   !! No arrays with indices to permute.
+
    SUBROUTINE obs_coo_tim( kcycle, &
       &                    kyea0,   kmon0,   kday0,   khou0,   kmin0,     &
@@ -1710,4 +1778,7 @@
       USE dom_oce, ONLY : &       ! Geographical information
          & gdepw_0                        
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
       !! * Arguments
@@ -1868,4 +1939,8 @@
    END SUBROUTINE obs_coo_spc_3d
 
+   !! * Reset control of array index permutation
+!FTRANS CLEAR
+   !! No arrays with indices to permute.
+
    SUBROUTINE obs_pro_rej( profdata )
       !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_altbias.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_altbias.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_altbias.F90	(revision 3211)
@@ -24,4 +24,7 @@
    USE dom_oce, ONLY : &        ! Domain variables
       & tmask, &
+#if defined key_z_first
+      & tmask_1, &
+#endif
       & tmask_i, &
       & e1t,   &
@@ -40,4 +43,7 @@
 
    PUBLIC obs_rea_altbias     ! Read the altimeter bias
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
@@ -175,6 +181,11 @@
          CALL obs_int_comm_2d( 2, 2, sladata(jslano)%nsurf, &
             &                  igrdi, igrdj, gphit, zgphi )
+#if defined key_z_first
+         CALL obs_int_comm_2d( 2, 2, sladata(jslano)%nsurf, &
+            &                  igrdi, igrdj, tmask_1(:,:), zmask )
+#else
          CALL obs_int_comm_2d( 2, 2, sladata(jslano)%nsurf, &
             &                  igrdi, igrdj, tmask(:,:,1), zmask )
+#endif
          CALL obs_int_comm_2d( 2, 2, sladata(jslano)%nsurf, &
             &                  igrdi, igrdj, z_altbias, zbias )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 3211)
@@ -34,4 +34,7 @@
 
    PUBLIC obs_rea_pro_dri  ! Read the profile observations 
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_seaice.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_seaice.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_seaice.F90	(revision 3211)
@@ -32,4 +32,7 @@
    PUBLIC obs_rea_seaice      ! Read the seaice observations from the point data
    
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
+
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sla.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sla.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sla.F90	(revision 3211)
@@ -31,4 +31,7 @@
 
    PUBLIC obs_rea_sla  ! Read the SLA observations from the AVISO/SLA database
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !!----------------------------------------------------------------------
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sst.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sst.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_sst.F90	(revision 3211)
@@ -33,4 +33,7 @@
    PUBLIC obs_rea_sst      ! Read the SST observations from the point data
    PUBLIC obs_rea_sst_rey  ! Read the gridded Reynolds SST 
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
    
    !!----------------------------------------------------------------------
@@ -694,5 +697,9 @@
       DO jj = nldj, nlej
          DO ji = nldi, nlei
+#if defined key_z_first
+            IF ( tmask_1(ji,jj) == 1.0_wp ) inumobs = inumobs + 1
+#else
             IF ( tmask(ji,jj,1) == 1.0_wp ) inumobs = inumobs + 1
+#endif
          END DO
       END DO
@@ -717,5 +724,9 @@
             DO ji = nldi, nlei
 
+#if defined key_z_first
+               IF ( tmask_1(ji,jj) == 1.0_wp ) THEN
+#else
                IF ( tmask(ji,jj,1) == 1.0_wp ) THEN
+#endif
 
                   inumobs = inumobs + 1
